package org.eclipse.papyrus.qompass.modellibs.core.xtend;

import org.eclipse.emf.common.util.EList;
import org.eclipse.papyrus.qompass.designer.core.UMLTool;
import org.eclipse.papyrus.qompass.modellibs.core.xtend.CppUtils;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.Type;
import org.eclipse.xtend2.lib.StringConcatenation;

@SuppressWarnings("all")
public class StructBasedMarshalling {
  public static CharSequence marshall(final Operation operation) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("struct ParamData {");
    _builder.newLine();
    {
      EList<Parameter> _parametersInInout = UMLTool.parametersInInout(operation);
      for(final Parameter parameter : _parametersInInout) {
        _builder.append("\t");
        Type _type = parameter.getType();
        CharSequence _cppType = CppUtils.cppType(_type);
        _builder.append(_cppType, "\t");
        _builder.append(" ");
        String _name = parameter.getName();
        _builder.append(_name, "\t");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("};");
    _builder.newLine();
    _builder.append("Event event;");
    _builder.newLine();
    _builder.append("event.ID = [operation.name/];");
    _builder.newLine();
    _builder.append("event.kind = CallEvent;");
    _builder.newLine();
    _builder.append("ParamData * data = &event.params;");
    _builder.newLine();
    {
      EList<Parameter> _parametersInInout_1 = UMLTool.parametersInInout(operation);
      for(final Parameter parameter_1 : _parametersInInout_1) {
        _builder.append("data->[parameter.name/] = [parameter.name/];");
        _builder.newLine();
      }
    }
    _builder.append("out->dispatch(event);");
    _builder.newLine();
    return _builder;
  }
}
